<?php
/*
|--------------------------------------------------------------------------
| admin.php 管理员表
|--------------------------------------------------------------------------
*/
# 定义几个常用的选项
$status = array
(
	1 => '普通',
	2 => '封禁',
);

$cur = Dever::load('manage/auth.data', false);

$desc = '';
if($cur['role'] > 1)
{
	$desc =  $cur['username'] . '，你好，你可以在此管理你的下属账号';

	$child = array_keys(Dever::db('manage/role')->all());

	$admin = Dever::db('manage/admin_role')->list(array
	(
		'col' => 'admin_id|admin_id',
		'option' => array
		(
			'role_id' => array('yes', 'in'),
		),
		'option_role_id' => implode(',', $child),
	));

	# 配置当前列表页的参数 只能查看自己下属的管理员
	Dever::$global['model']['manage/admin-list'] = array
	(
		'option' => array
		(
			'id' => array('yes', 'in'),
		),
		'option_id' => $admin ? array_keys($admin) : -1,
	);
}

$role = function()
{
	return Dever::load('manage/role-all');
};

$group = function()
{
	return Dever::load('manage/group-all');
};

$config = function()
{
	return Dever::load('manage/config-all');
};

# 获取头部菜单list 建议这里使用匿名函数
$top = function()
{
	$data = Dever::load('manage/top.all');
	$data['state'] = 1;
	return $data;
};

return array
(
	# 表名
	'name' => 'admin',
	# 显示给用户看的名称
	'lang' => '管理账户设置',
	'desc' => $desc,

	/* 设置上级菜单，当config里设置menu后，这里将失效
	'parent' => array
	(
		'key' => 'kefu',
		'order' => 1,
		'name' => '客服设置',
	),
	*/

	# 这个表不使用cache功能
	//'cache' => false,
	/*
	# 用到哪个后台菜单上，对应项目的key
	'menu' => 'project_niuyou_main',
	# 后台菜单排序
	'order' => 10,
	# 显示到后台快捷发布中，值为排序
	'fast' => 1,
	*/
	'order' => 9,

	# 检测email必须唯一
	'check' => 'email',
	# 同步更新另外一个或多个表的多条关联数据，以逗号隔开
	'sync' => array
	(
		'manage/admin_role' => array
		(
			# 更新时的条件，另外一个表的字段 => 本表的字段
			'where' => array('admin_id' => 'id'),
			# 要更新的数据
			'update' => array('role_id' => 'role'),
			# 同步更新的类型，delete为先删再插入，update为先查询是否存在，存在直接更新，不存在则插入, only为仅更新
			'type' => 'delete',
		)
	),


	# 同步更新另外一个或多个表的一条关联数据
	/*
	'syncone' => array
	(
		'manage/admin_role' => array
		(
			# 更新另外一个表的字段 => 本表的字段
			'where' => array('admin_id' => 'id'),
			# 要更新的数据
			'update' => array('role_id' => 'role'),
		)
	),
	*/

	/*该方法用check替代
	'start' => array
	(
		'update' => 'manage/auth.check',
		'insert' => 'manage/auth.check',
	),
	*/
	'end' => array
	(
		'update' => 'manage/auth.update',
	),
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '管理员ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),
		
		'username'		=> array
		(
			'type' 		=> 'varchar-24',
			'name' 		=> '管理员名',
			'default' 	=> '',
			'desc' 		=> '请输入管理员名',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			# 自动完成功能，第一个参数是请求的地址，请自行实现，第二个参数是要使用的字段，共有id和value两个选择，id会特殊处理，value则直接把当前值写入，第三个参数是直接替换当前的值，第四个参数是当前表里的字段名，一般为分类的id
			//'autocomplete' => array('auth.role?json=1', 'value', 'manage/role-check#name', 'cate_id'),
			//'autocomplete' => array('auth.role?json=1'),
			'search'	=> 'order,fulltext',
			'list'		=> true,
			# 绑定js脚本，更新时使用，第一个参数是执行的方式，第二个参数执行的方法，第三个参数是传值。
			//'bind'		=> array('onblur', 'loading', array('url' => Dever::url("auth.blur"))),
		),

		#多级联动
		//'update'	=> 'linkage',//多级联动 option参数：请求地址（返回参数为level_num当前联动级数，level_id当前选择的id），参考area组件：dever package area
		//'option'	=> Dever::url('api.get', 'area'),

		'email'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '邮箱-可用于登录，请准确填写，不允许重复',
			'default' 	=> '',
			'desc' 		=> '请输入邮箱',
			'match' 	=> Dever::rule('email'),
			'update'	=> 'text',
			/*
			* 列表页搜索选项，这里的search或者update的值为
			* fulltext：全文检索,模糊匹配
			* text：精确匹配
			* exp：大小判断，仅能选择一项
			* select：选择器，需要option项
			* group：组选择器，需要option项
			* linkage：多级联动选择器，需要option项，值为联动数据接口地址，参考area组件 'option'	=> Dever::url('api.get', 'area'), 'list'		=> 'Dever::load("area/api.string", "{area}")',
			* exist：是否存在，需要exist项，基本配置为
			$source_id = array
			(
				'yes' => '有值',
				'no' => '没有值',
				'no|2832' => '没有值或者有值为2832',
				'yes|2832' => '有值并且过滤值为2829',
				'2832' => '查找',
			);
			* 如果search的值为数组，则认为是接口，需要从接口获取数据后再进行查找
			* 如'search'	=> array
			(
				'api' => 'passport/user-all',//接口地址，最好是获取多条数据的地址
				'col' => 'name',//要查询的字段
				'result' => 'id',//返回的字段
				'search' => 'uid',//本表的字段，默认为当前的字段
			),
			* 就是将本字段email当做passport/user-one的name字段来查找id
			*/
			'search'	=> 'fulltext',
			'list'		=> true,
			# 在手机版或者小屏幕下，列表页的表格是否展示，1为展示，2、3、4、5、6均为在一定宽度下展示，详细参考：https://github.com/nadangergeo/RWD-Table-Patterns
			'level'		=> 1,

			//直接上传到云端
			//'upload'	=> 'qiniu',
			//上传大数据
			//'large' 	=> true,
		),

		# 比较特殊的一些设置，不断添加中：
		/*
		'cate'		=> array
		(
			'type' 		=> 'varchar-300',
			'name' 		=> '标签分类',
			'default' 	=> '1',
			'desc' 		=> '标签分类',
			'match' 	=> 'is_string',
			'update'	=> 'select',
			'option'	=> $cate,
			'search'	=> 'fulltext',
			//'list'		=> true,
			'control'	=> 'cate',
		),
		
		# 标签，根据分类变化的标签
		'tag'		=> array
		(
			'type' 		=> 'varchar-300',
			'name' 		=> '标签',
			'default' 	=> '',
			'desc' 		=> '标签',
			'match' 	=> 'is_string',
			'update'	=> 'checkbox',
			# 新增接口 暂未实现
			'adding'	=> 'tag/manage.getByCate?cate=',
			# 开启这个，需要将update更换为text类型，输入文字即可选择标签
			//'autocomplete' => array('tag/manage.getByName', 'id', 'tag/info-one#name'),
			'search'	=> 'fulltext',
			//'list'		=> true,
			# 与上边的cate联动（ajax）
			'show'	=> 'cate=tag/manage.getByCate?cate=',
		),
		
		# 加载地图
		'map'		=> array
		(
			'type' 		=> 'varchar-300',
			'name' 		=> '地理位置',
			'default' 	=> '',
			'desc' 		=> '地理位置',
			'match' 	=> 'is_string',
			# 如果是map，必须在config的base.php中设置map信息
			//'update'	=> 'map',
			'search'	=> 'fulltext',
			//'list'		=> true,

			//自定义编辑器右侧按钮
			'editor'	=> array
			(
				'name' => '选择插入模块',
				'button' => array
				(
					array
					(
						# 名称
						'name' => '图片',
						# 资源库id
						'key' => 1,
						# 类型
						'type' => 'image',
					),
					array
					(
						'name' => '音频',
						'key' => 2,
						'type' => 'media',
					),
					array
					(
						'name' => '视频',
						'key' => 'video/lib/core.vod',
					),
					array
					(
						'name' => '直播',
						'key' => 'video/lib/core.live',
					),
				),
			),
		),

		# 三级地区联动
		'area'		=> array
		(
			'type' 		=> 'varchar-100',
			'name' 		=> '地区',
			'default' 	=> '',
			'desc' 		=> '地区',
			'match' 	=> 'is_string',
			'search'	=> 'linkage',
			'update'	=> 'linkage',//多级联动 option参数：请求地址（参数为level_num当前联动级数，level_id当前选择的id）
			'option'	=> Dever::url('api.get', 'area'),
			'list'		=> 'Dever::load("area/api.string", "{area}")',
		),

		# 无限级联动
		'category'		=> array
		(
			'type' 		=> 'varchar-500',
			'name' 		=> '分类',
			'default' 	=> '',
			'desc' 		=> '分类',
			'match' 	=> 'is_string',
			'search'	=> 'linkage',
			//'update'	=> 'linkage',
			'option'	=> Dever::url('api.get', 'category'),
			'list'		=> 'Dever::load("category/api.string", "{category}")',
		),

		# 属性管理
		'attr'		=> array
		(
			'type' 		=> 'varchar-800',
			'name' 		=> '属性设置',
			'default' 	=> '',
			'desc' 		=> '属性设置',
			'match' 	=> 'option',
			'update'	=> 'checkbox',
			'option'	=> $attr,
			'update_input' => '',
			'update_input_default' => '',
			'update_parent' => 'checkbox',
		),

		# 属性管理 需要用这个来设置值
		'attr_input'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '属性值设置',
			'default' 	=> '',
			'desc' 		=> '属性值设置',
			'match' 	=> 'option',
		),
		*/

		'mobile'		=> array
		(
			'type' 		=> 'varchar-32',
			'name' 		=> '手机号',
			'default' 	=> '',
			'desc' 		=> '请输入手机号',
			'match' 	=> Dever::rule('mobile'),
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
			'level'		=> 1,
			# 显示在table中
			//'list_table'=> '111',
		),
		
		'password'		=> array
		(
			'type' 		=> 'varchar-64',
			'name' 		=> '管理员密码',
			'default' 	=> '',
			'desc' 		=> '请输入管理员密码',
			'match' 	=> 'option',
			'update'	=> 'password',
			'callback'	=> 'hash.sha256',
		),
		
		'config'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '后台配置',
			'default' 	=> '1',
			'desc' 		=> '请选择后台配置',
			'match' 	=> 'is_numeric',
			'option' 	=> $config,
			'update'	=> 'select',
			'list'		=> true,
		),
		
		'role'		=> array
		(
			'type' 		=> 'varchar-100',
			'name' 		=> '角色',
			'default' 	=> '1',
			'desc' 		=> '请选择角色',
			'match' 	=> 'is_string',
			'option' 	=> $role,
			'update'	=> 'checkbox',
			//'list'		=> true,
		),

		'group'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '分组',
			'default' 	=> '1',
			'desc' 		=> '请选择分组',
			'match' 	=> 'is_numeric',
			'option' 	=> $group,
			'update'	=> 'select',
			//'list'		=> true,
		),

		'top'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '头部菜单-这里的头部菜单如果设置，则会覆盖角色中的头部菜单',
			'default' 	=> '',
			'desc' 		=> '请选择头部菜单',
			'match' 	=> 'option',
			'update'	=> 'checkbox',
			'option'	=> $top,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '数据状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
			//'option' 	=> $option,
			//'update'	=> 'radio',
			//'list'		=> true,
			//'extend'	=> true,//扩展功能，该字段为虚拟字段，只在数据库中建立extend字段来保存 后续实现
		),

		/*
		提供冲突检测机制（乐观锁），保证高并发下的数据安全
		这是模仿自 php 的 Memcached 扩展 后续实现
		'token'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'token',
			'default' 	=> '1',
			'desc' 		=> 'token',
			'match' 	=> 'is_numeric',
		),
		*/

		'status'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
			'option' 	=> $status,
			'update'	=> 'radio',
			'list'		=> true,
			'edit'		=> true,
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', DEVER_TIME),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		'delete' => false,
		// 载入自定义资源
		'res' => array
		(
			'js' => 'demo',
			'css' => 'demo',
		),

		# 快捷更新
		/*
		'list_button' => array
		(
			'edit' => array('审核', 'name'),
		),
		*/


		/*
		'insert' => false,
		'edit' => false,
		//'delete' => false,

		# 自定义快捷新增和编辑
		'button' => array
		(
			'新增' => array('fast', 'name,reorder'),
		),
		# 快捷更新
		'list_button' => array
		(
			'edit' => array('编辑', 'name,reorder'),
		),
		*/
	),
	
	# 更新表结构
	'alter' => array
	(
		2 => array
		(
			//array('update', 'role', 'role', 'varchar-100 1 角色'),
			//array('add', 'config', 'config', 'int-11 1 配置'),
		),
		'version' => 2,
	),
	
	# 默认值
	/*
	'default' => array
	(
		'col' => 'username,email,password,role,state,cdate',
		'value' => array
		(
			//'"DMC","DMC@dever.cc","'. md5('admin_' . date('Y_m_d_H')) . '",1, 1,' . time(),
			'"admin","DMC@dever.cc","'. hash('sha256', 'admin_123') . '",1, 1,' . DEVER_TIME,
		),
	),
	*/
	
	# 索引
	'index' => array
	(
		# 索引名 => 索引id
		//'id' => 'id,state',
	),
	
	# request 请求接口定义
	'request' => array
	(
		# one 根据用户名和密码取一条数据
		'user' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				//'username' => '/^([A-Za-z0-9])/',
				//'username' => 'yes',
				'email' => 'yes',
				'status' => 1,
				'state' => 1,
				//'password' => 'is_string',
			),
			'type' => 'one',
			# 为这个接口独立设置缓存
			'cache' => true,
		),

		# one 根据用户名和密码取一条数据
		'email' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				//'username' => '/^([A-Za-z0-9])/',
				//'username' => 'yes',
				'email' => 'yes',
				'status' => 1,
				'state' => 1,
				//'password' => 'is_string',
			),
			'type' => 'one',
			# 为这个接口独立设置缓存
			'cache' => true,
		),

		# one 根据用户名和密码取一条数据
		'mobile' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				//'username' => '/^([A-Za-z0-9])/',
				//'username' => 'yes',
				'mobile' => 'yes',
				'status' => 1,
				'state' => 1,
				//'password' => 'is_string',
			),
			'type' => 'one',
			# 为这个接口独立设置缓存
			'cache' => true,
		),
		
		# 更新密码
		'password' => array
		(
			'type' => 'update',
			'where' => array
			(
				'id' => 'yes',
			),
			'set' => array
			(
				'password' => 'yes',
			),
		),
	),
);
