<?php

# 定义几个常用的选项
$option = array
(
	1 => '生效',
	2 => '失效',
);

return array
(
	# 表名
	'name' => 'filter_task',
	# 显示给用户看的名称
	'lang' => '过滤系统任务',
	'menu' => false,
	'check' => 'content.s',
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'order'		=> 'desc',
		),

		'name'		=> array
		(
			'type' 		=> 'varchar-100',
			'name' 		=> '表名+id',
			'default' 	=> '',
			'desc' 		=> '请输入表名+id',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),
		
		'content'		=> array
		(
			'type' 		=> 'text-255',
			'name' 		=> '过滤的内容',
			'default' 	=> '',
			'desc' 		=> '请输入过滤的内容',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			//'list'		=> true,
		),
	
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> array('is_numeric', 1),
			'option' 	=> $option,
			'update'	=> 'radio',
			'list'		=> true,
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	# request 请求接口定义
	'request' => array
	(
		'data' => array
		(
			'limit' => array(10, 0),
			'type' => 'all',
			'order' => array('id', 'asc'),
			'col' => 'id,name,content|id',
		),

		'dels' => array
		(
			'where' => array
			(
				'id' => array('yes', 'in'),
			),
			'type' => 'delete',
		),
	)
);
